package me.Demon.DemonChestPreview.Command;

import me.Demon.DemonChestPreview.Main;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class ChestCommand implements CommandExecutor, TabExecutor {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        Player p = (Player) sender;
        if (args.length == 1) {
            if (args[0].equalsIgnoreCase("add") && sender.isOp()) {
                Block targetBlock = p.getTargetBlock(null, 5);
                if (targetBlock != null && targetBlock.getType() == Material.CHEST) {
                    String loc = getLoc(targetBlock);
                    if (!Main.previewList.contains(loc)) {
                        List<String> list = Main.previewList;
                        list.add(loc);
                        Main.plugin.getConfig().set("ChestLoc", list);
                        Main.plugin.saveConfig();
                        p.sendMessage(Main.prefix + "已添加箱子展示箱 §7#" + loc);
                    } else {
                        p.sendMessage(Main.prefix + "此箱子已存在展示坐标内.");
                    }
                } else {
                    p.sendMessage(Main.prefix + "添加失败,指向的物品类型不是箱子.");
                }
            } else if (args[0].equalsIgnoreCase("del") && sender.isOp()) {
                Block targetBlock = p.getTargetBlock(null, 5);
                if (targetBlock != null && targetBlock.getType() == Material.CHEST) {
                    String loc = getLoc(targetBlock);
                    if (Main.previewList.contains(loc)) {
                        List<String> list = Main.previewList;
                        list.remove(loc);
                        Main.plugin.getConfig().set("ChestLoc", list);
                        Main.plugin.saveConfig();
                        p.sendMessage(Main.prefix + "已删除箱子展示箱 §7#" + loc);
                    } else {
                        p.sendMessage(Main.prefix + "此箱子不存在展示坐标内.");
                    }
                } else {
                    p.sendMessage(Main.prefix + "删除失败,指向的物品类型不是箱子.");
                }
            }
        }
        return false;
    }

    private static String getLoc(Block targetBlock) {
        Location chestLocation = targetBlock.getLocation();
        String world = chestLocation.getWorld().getName();
        int x = chestLocation.getBlockX();
        int y = chestLocation.getBlockY();
        int z = chestLocation.getBlockZ();
        return world + "," + x + "," + y + "," + z;
    }

    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> list = new ArrayList<>();
        if (args.length == 1) {
            if (sender.isOp()) {
                list.add("add");
                list.add("del");
            }
            return list;
        }
        return null;
    }
}